<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%@page import="java.net.*,
                java.io.*,
                java.util.*,
                blackboard.platform.*,
                blackboard.persist.*,
                blackboard.data.user.*,
                blackboard.persist.user.*,
                blackboard.data.course.*,
                blackboard.persist.course.*,
                javax.xml.datatype.DatatypeFactory,
                com.atlassys.products.ares.webservice.*
                "%>  
<%@ taglib uri="/bbData" prefix="bbData" %>
<%@ taglib uri="/bbNG" prefix="bbNG"%>

<%@ include file="/WEB-INF/library/include.jspf" %>

<%
    PlugInConfig pic = new PlugInConfig(PLUGIN_VID, PLUGIN_HANDLE );                 
    LoadProperties(pic);    
%>

<bbNG:learningSystemPage ctxId="ctx">
    
<%
    final java.lang.Integer INVALID_SEMESTER_RESULT = -1; // This exists in view.jsp, include.jspf, and manualsemester.jsp

    boolean sendRedirect = false;
    boolean redirectForSemester = false;
    java.lang.String outputDisplay = "";
    java.lang.String redirectURL = "";
    java.lang.String aresWebSessionId = "";
    java.lang.String pageTitle = "Course Reserves";    
    java.lang.String aresCoursePage = "";    
    java.lang.String instructorAresUserName = "";
    java.lang.String instructorAresFamilyName = "";
    java.lang.String aresUserName = "";    
    java.lang.String aresFirstName = "";
    java.lang.String aresLastName = "";
    java.lang.String aresEmailAddress = "";
    java.lang.String bbUniqueUserId = "";
    java.lang.String aresDepartment = "";
    java.lang.String bbStudentId = "";
    java.lang.String courseSemester = "";

    java.lang.Boolean aresUserExists = false;
    java.lang.Boolean continueProcessing = true;
    
    java.lang.Integer aresClassId = 0;
    
    try
    {
        com.atlassys.products.ares.webservice.AresWebServiceLocator locator = new com.atlassys.products.ares.webservice.AresWebServiceLocator();    
        com.atlassys.products.ares.webservice.AresWebServiceSoapStub port = (com.atlassys.products.ares.webservice.AresWebServiceSoapStub) locator.getAresWebServiceSoap();    
        port._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, wsURLText);
        
        if (verboseErrorValue.equals("2"))
        {            
            outputDisplay = String.format("%1$sInitialize Ares WebService to %2$s.<br/>", outputDisplay, wsURLText);                
        }
        
        if (verboseErrorValue.equals("2"))
        {            
            outputDisplay = String.format("%1$sCreating an instance of the DbPersistenceManager.<br/>", outputDisplay);             
        }
        
        //Retrieve the Db persistence manager from the persistence service
        BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();
    
        //Get the Current Course
        Course sessionCourse;
        User user;

        if (request.getParameter("cbuid") != null)
        {
            if (verboseErrorValue.equals("2"))
            {            
                outputDisplay = String.format("%1$scbuid was found in the request. Using the CourseDbLoader to get an isntance of the course. CBUID = %2$s.<br/>", outputDisplay, request.getParameter("cbuid"));
            }
            
            sessionCourse = CourseDbLoader.Default.getInstance().loadByBatchUid(request.getParameter("cbuid"));
        }
        else
        {
            if (verboseErrorValue.equals("2"))
            {            
		outputDisplay = String.format("%1$sAttempting to retrieve course from the Context.<br/>", outputDisplay);
            }

            sessionCourse = ctx.getCourse();                          
        }

        if (verboseErrorValue.equals("2"))
        {            
            if (sessionCourse == null)
            {
		outputDisplay = String.format("%1$sThe course object retrieved was null.<br/>", outputDisplay);                           
            }
            else
            {
                outputDisplay = String.format("%1$sCourse Batch Id: %2$s<br/>", outputDisplay, sessionCourse.getBatchUid());
                outputDisplay = String.format("%1$sCourse CourseId: %2$s<br/>", outputDisplay, sessionCourse.getCourseId());
                outputDisplay = String.format("%1$sCourse Created Date: %2$s<br/>", outputDisplay, sessionCourse.getCreatedDate());
                outputDisplay = String.format("%1$sCourse Description: %2$s<br/>", outputDisplay, sessionCourse.getDescription());
                outputDisplay = String.format("%1$sCourse Duration Type: %2$s<br/>", outputDisplay, sessionCourse.getDurationType());
                outputDisplay = String.format("%1$sCourse Start Date: %2$s<br/>", outputDisplay, sessionCourse.getStartDate());
                outputDisplay = String.format("%1$sCourse End Date: %2$s<br/>", outputDisplay, sessionCourse.getEndDate());
                outputDisplay = String.format("%1$sCourse Enrollment Type: %2$s<br/>", outputDisplay, sessionCourse.getEnrollmentType());
                outputDisplay = String.format("%1$sCourse Id: %2$s<br/>", outputDisplay, sessionCourse.getId());
                outputDisplay = String.format("%1$sCourse Title: %2$s<br/>", outputDisplay, sessionCourse.getTitle());
            }            
        }

        if (request.getParameter("ubuid") != null)
        {
            if (verboseErrorValue.equals("2"))
            {       
                outputDisplay = String.format("%1$subuid was found in the request. Using the UserDbLoader to get an instance of the user. UBUID = %2$s.<br/>", outputDisplay, request.getParameter("ubuid"));  
            }
            
            user = blackboard.persist.user.UserDbLoader.Default.getInstance().loadByBatchUid(request.getParameter("ubuid"));
        }
        else
        {            
            if (verboseErrorValue.equals("2"))
            {            
                outputDisplay = String.format("%1$sAttempting to retrieve user from the Context.<br/>", outputDisplay);    
            }
            
            user = ctx.getUser();       
        }
        
        if (verboseErrorValue.equals("2"))
        {            
            if (user == null)
            {
                outputDisplay = String.format("%1$sThe user object retrieved was null.<br/>", outputDisplay);
            }
            else
            {                
                outputDisplay = String.format("%1$sUser Batch Id: %2$s<br/>", outputDisplay, user.getBatchUid());
                outputDisplay = String.format("%1$sUser Username: %2$s<br/>", outputDisplay, user.getUserName());
                outputDisplay = String.format("%1$sUser Id: %2$s<br/>", outputDisplay, user.getId());
                outputDisplay = String.format("%1$sUser Last Name: %2$s<br/>", outputDisplay, user.getFamilyName());
                outputDisplay = String.format("%1$sUser First Name: %2$s<br/>", outputDisplay, user.getGivenName());
                outputDisplay = String.format("%1$sUser Department: %2$s<br/>", outputDisplay, user.getDepartment());
                outputDisplay = String.format("%1$sUser City: %2$s<br/>", outputDisplay, user.getCity());
                outputDisplay = String.format("%1$sUser State: %2$s<br/>", outputDisplay, user.getState());
                outputDisplay = String.format("%1$sUser Country: %2$s<br/>", outputDisplay, user.getCountry());
                outputDisplay = String.format("%1$sUser Email Address: %2$s<br/>", outputDisplay, user.getEmailAddress());
                outputDisplay = String.format("%1$sUser Student Id: %2$s<br/>", outputDisplay, user.getStudentId());
                outputDisplay = String.format("%1$sUser System Role: %2$s<br/>", outputDisplay, user.getSystemRole());
                outputDisplay = String.format("%1$sUser Title: %2$s<br/>", outputDisplay, user.getTitle());			   
            }            
        }
                
        java.lang.String bbUniqueCourseId = sessionCourse.getBatchUid();
        
        // get the membership data to determine the User's Role
        CourseMembership crsMembership = null;
        CourseMembershipDbLoader crsMembershipLoader = null;

        try
        {
            if (verboseErrorValue.equals("2"))
            {                        
                outputDisplay = String.format("%1$sInitializing the course membership loader from the Persistence Manager.<br/>", outputDisplay); 
            }
        
            crsMembershipLoader = (CourseMembershipDbLoader) bbPm.getLoader(CourseMembershipDbLoader.TYPE);
    
            if (verboseErrorValue.equals("2"))
            {                        
                outputDisplay = String.format("%1$sRetrieving course membership for Course: %2$s. User: %3$s.<br/>", outputDisplay, sessionCourse.getId(), user.getId());                             
            }
            
            crsMembership = crsMembershipLoader.loadByCourseAndUserId(sessionCourse.getId(), user.getId());

            try 
            {
                if (verboseErrorValue.equals("2"))
                {                        
                    outputDisplay = String.format("%1$sChecking Ares for External User Id of %2$s.<br/>", outputDisplay, user.getBatchUid());
                }
                
                aresUserName = port.retrieveUsernameForExternalUserId(user.getBatchUid());

                aresUserExists = ((aresUserName != null) && (aresUserName.trim().length() != 0));

                if (verboseErrorValue.equals("2"))
                {                        
                    outputDisplay = String.format("%1$sAres User Exists for External User Id of %2$s: %3$s.<br/>", outputDisplay, user.getBatchUid(), aresUserExists);
                }
                                
                if (aresUserExists == false)
                {
                    if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                    {            
                        outputDisplay = String.format("%1$sCould not find Ares External UserId: %2$s. Checking if Ares Username of %2$s exists.<br/>", outputDisplay, user.getBatchUid());         
                    }

                    if (port.userExists(user.getBatchUid()))
                    {
                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                        {            
                            outputDisplay = String.format("%1$sFound Ares Username %2$s.<br/>", outputDisplay, user.getBatchUid());
                        }

                        aresUserName = user.getBatchUid();
                        aresUserExists = true;
                    }
                    
                    if (!aresUserExists)
                    {
                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                        {            
                            outputDisplay = String.format("%1$sCould not find Ares Username %2$s. Checking if Ares Username %3$s exists<br/>", outputDisplay, user.getBatchUid(), user.getUserName());
                        }
                        
                        if (port.userExists(user.getUserName()))
                        {
                            if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                            {            
                                outputDisplay = String.format("%1$sFound Ares Username %2$s.<br/>", outputDisplay, user.getUserName());
                            }

                            aresUserName = user.getUserName();
                            aresUserExists = true;
                        }
                    }
                }
                else
                {
                    if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                    {            
                        outputDisplay = String.format("%1$sExternalUserID of %2$s matched Ares Username: %3$s.<br/>", outputDisplay, user.getBatchUid(), aresUserName);
                    }
                }

                if ((aresUserExists == false) && (pageTitle != "Error"))
                { 
                    aresUserName = user.getUserName();
                    aresFirstName = user.getGivenName();
                    aresLastName = user.getFamilyName();
                    aresEmailAddress = user.getEmailAddress();
                    bbUniqueUserId = user.getBatchUid();
                    aresDepartment = user.getDepartment();

                    try 
                    {
                        try
                        {                           
                            bbStudentId = user.getStudentId();
                        }
                        catch (Exception e)
                        {
                            bbStudentId = "";                        
                        }

                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                        {            
                            outputDisplay = String.format("%1$sCreating Ares Username %2$s.<br/>", outputDisplay, aresUserName);
                        }

                        boolean newUserResult = port.newExternalUser (aresUserName,  aresFirstName, aresLastName, bbStudentId, aresEmailAddress, "User", aresDepartment,bbUniqueUserId);

                        if (verboseErrorValue.equals("1"))
                        {
                            outputDisplay = String.format("%1$sUser Info<br/>", outputDisplay);
                            outputDisplay = String.format("%1$sBatchUid: %2$s.<br/>", outputDisplay, user.getBatchUid());
                            outputDisplay = String.format("%1$sFirstName: %2$s.<br/>", outputDisplay, user.getGivenName());
                            outputDisplay = String.format("%1$sLastName: %2$s.<br/>", outputDisplay, user.getFamilyName());
                            outputDisplay = String.format("%1$sUsername: %2$s.<br/>", outputDisplay, user.getUserName());    
                        }

                        if (newUserResult)
                        {
                            if (verboseErrorValue.equals("2"))
                            {
                                outputDisplay = String.format("%1$sAres User Created: %2$s<br/>", outputDisplay, aresUserName);
                            }
                            aresUserExists = true;
                        }
                        else
                        {
                            if (verboseErrorValue.equals("2"))
                            {
                                outputDisplay = String.format("%1$sAres User Not Created: %2$s<br/>", outputDisplay, aresUserName);
                            }
                        }                                                                   
                    } 
                    catch (Exception ex) 
                    {
                        continueProcessing = false;

                        outputDisplay = String.format("%1$s<h4>Could not transfer your user information to Ares Course Reserves</h4><br/>", outputDisplay);

                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                        {                                               
                            outputDisplay = String.format("%1$s%2$s<br/>", outputDisplay, ex.getMessage());
                        }
                    }          
                }            

                if (verboseErrorValue.equals("2"))
                {
                    outputDisplay = String.format("%1$sRetrieving current Blackboard Course Role.<br/>", outputDisplay);
                }
                
                blackboard.data.course.CourseMembership.Role currentRole = crsMembership.getRole();

                if (verboseErrorValue.equals("2"))
                {
                    outputDisplay = String.format("%1$sCourse Role: %2$s.<br/>", outputDisplay, currentRole);
                }
                
                bbUniqueCourseId = sessionCourse.getBatchUid();

                if (verboseErrorValue.equals("2"))
                {
                    outputDisplay = String.format("%1$sAttempting to retrive course by external id: %2$s<br/>", outputDisplay, bbUniqueCourseId);
                }
                
                MyCourse result = port.getCourseByExternalId(bbUniqueCourseId);
                
                if (verboseErrorValue.equals("2"))
                {
                    outputDisplay = String.format("%1$sAres Class ID: %2$s<br/>", outputDisplay, result.getClassId());
                }
                
                aresClassId = result.getClassId();

                if ((aresUserExists) && (aresClassId == 0))
                {
                    if ((currentRole == CourseMembership.Role.INSTRUCTOR) ||
                       (currentRole == CourseMembership.Role.COURSE_BUILDER) ||
                       (currentRole == CourseMembership.Role.TEACHING_ASSISTANT))
                    {                                 
                        pageTitle = instructorPageTitleText;                    

                        // Get semester name if it was sent from ManualSemester

                        if (request.getParameter("csem") != null)
                        {
                            if(verboseErrorValue.equals("2"))
                            {
                                outputDisplay = String.format("%1$scsem was found in the request. Using semester name for course creation. CourseSemester = %2$s.<br/>", outputDisplay, request.getParameter("csem"));
                            }

                            courseSemester = request.getParameter("csem");
                        }

                        //Create the Class if a valid course role (Course Builder/Instructor/TA)
		
                        if (currentRole == blackboard.data.course.CourseMembership.Role.INSTRUCTOR)
                        {
                            if (verboseErrorValue.equals("2"))
                            {                                
                                outputDisplay = String.format("%1$sAssigning Instructor Privileges to Ares User: %2$s<br/>", outputDisplay, aresUserName );
                            }
                            
                            boolean instructorPrivs = port.instructorPrivileges(aresUserName);    

                            if (verboseErrorValue.equals("2"))
                            {                                
                                outputDisplay = String.format("%1$sCurrent User is Blackboard Instructor. Creating Course in Ares with %2$s as the instructor.<br/>", outputDisplay, aresUserName);
                            }

                            if(semesterOptionValue.compareToIgnoreCase("2") == 0 && courseSemester.compareToIgnoreCase("") == 0)
                            {
                                aresClassId = INVALID_SEMESTER_RESULT;
                            }
                            else
                            {
                                aresClassId = CreateCourse(user.getFamilyName() , aresUserName , sessionCourse, out, courseSemester);	
                            }
                        }
                        else
                        {
                            if ((currentRole == blackboard.data.course.CourseMembership.Role.COURSE_BUILDER) ||
                            (currentRole == blackboard.data.course.CourseMembership.Role.TEACHING_ASSISTANT))
                            {
                                if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                {            
                                    outputDisplay = String.format("%1$sRetrieving Course Instructors to create the course<br/>", outputDisplay);
                                }

                                //Get the first instructor in the list
                                UserDbLoader userDbLoader = (UserDbLoader) bbPm.getLoader( UserDbLoader.TYPE );                       
                                CourseMembershipDbLoader cmLoader = CourseMembershipDbLoader.Default.getInstance();
                                BbList instructorList = cmLoader.loadByCourseIdAndRole(sessionCourse.getId(), CourseMembership.Role.INSTRUCTOR);                      
                                CourseMembership cm = null;

                                FilteringIterator itr = instructorList.getFilteringIterator();                                                       

                                if (itr.hasNext())
                                {
                                    if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                    {            
                                        outputDisplay = String.format("%1$sIterating through Instructors<br/>", outputDisplay);
                                    }

                                    cm = (CourseMembership)itr.next();
                                    Id theId = cm.getUserId();

                                    User instructor = userDbLoader.loadById(theId);  

                                    if (verboseErrorValue.equals("2"))
                                    {    
                                        outputDisplay = String.format("%1$sInstructor Batch Id: %2$s<br/>", outputDisplay, instructor.getBatchUid());
                                        outputDisplay = String.format("%1$sInstructor Username: %2$s<br/>", outputDisplay, instructor.getUserName());
                                        outputDisplay = String.format("%1$sInstructor Id: %2$s<br/>", outputDisplay, instructor.getId());
                                        outputDisplay = String.format("%1$sInstructor Last Name: %2$s<br/>", outputDisplay, instructor.getFamilyName());
                                        outputDisplay = String.format("%1$sInstructor First Name: %2$s<br/>", outputDisplay, instructor.getGivenName() );
                                        outputDisplay = String.format("%1$sInstructor Department: %2$s<br/>", outputDisplay, instructor.getDepartment());
                                        outputDisplay = String.format("%1$sInstructor City: %2$s<br/>", outputDisplay, instructor.getCity());
                                        outputDisplay = String.format("%1$sInstructor State: %2$s<br/>", outputDisplay, instructor.getState());
                                        outputDisplay = String.format("%1$sInstructor Country: %2$s<br/>", outputDisplay, instructor.getCountry());
                                        outputDisplay = String.format("%1$sInstructor Email Address: %2$s<br/>", outputDisplay, instructor.getEmailAddress());
                                        outputDisplay = String.format("%1$sInstructor Student Id: %2$s<br/>", outputDisplay, instructor.getStudentId());
                                        outputDisplay = String.format("%1$sInstructor System Role: %2$s<br/>", outputDisplay, instructor.getSystemRole());
                                        outputDisplay = String.format("%1$sInstructor Title: %2$s<br/>", outputDisplay, instructor.getTitle());            
                                    }
                                    
                                    if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                    {            
                                        outputDisplay = String.format("%1$s(Course Instructors) Checking for Ares User by External User Id: %2$s<br/>", outputDisplay, instructor.getBatchUid());
                                    }
                                    
                                    instructorAresUserName = port.retrieveUsernameForExternalUserId(instructor.getBatchUid());
                                    
                                    instructorAresFamilyName = instructor.getFamilyName();

                                    if ((instructorAresUserName == null) || (instructorAresUserName.trim().length() == 0))
                                    {
                                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                        {            
                                            outputDisplay = String.format("%1$s(Course Instructors) Could not find Ares External UserId: %2$s. Checking if Ares Username of %2$s exists.<br/>", outputDisplay, instructor.getBatchUid());
                                        }

                                        if (port.userExists(instructor.getBatchUid()))
                                        {
                                            instructorAresUserName = instructor.getBatchUid();                                            

                                            if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("1")))
                                            {            
                                                outputDisplay = String.format("%1$s(Course Instructors) ExternalUserID of %2$s matched Ares Username: %3$s<br/>", outputDisplay, instructor.getBatchUid(), instructorAresUserName);
                                            }
                                        }
                                        else
                                        {
                                            instructorAresUserName = instructor.getUserName();                                            

                                            if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                            {            
                                                outputDisplay = String.format("%1$sCould not find instructor in Ares. Creating instructor user account for  %2$s.<br/>", outputDisplay, instructor.getBatchUid());
                                            }

                                            try
                                            {                           
                                                bbStudentId = instructor.getStudentId();
                                            }
                                            catch (Exception e)
                                            {
                                                bbStudentId = "";                        
                                            }

                                            boolean newInstructorResult = port.newExternalUser(instructorAresUserName, instructor.getGivenName(), instructor.getGivenName(), bbStudentId, instructor.getEmailAddress(), "User", instructor.getDepartment(), instructor.getBatchUid());

                                            if (verboseErrorValue.equals("1"))
                                            {
                                                outputDisplay = String.format("%1$sInstructor Info<br/>", outputDisplay);
                                                outputDisplay = String.format("%1$sBatchUid: %2$s<br/>", outputDisplay, instructor.getBatchUid());
                                                outputDisplay = String.format("%1$sFirstName %2$s<br/>", outputDisplay, instructor.getGivenName());
                                                outputDisplay = String.format("%1$sLastName %2$s<br/>", outputDisplay, instructor.getFamilyName());
                                                outputDisplay = String.format("%1$sUsername %2$s<br/>", outputDisplay, instructor.getUserName());          
                                            }

                                            if (! newInstructorResult)
                                            {
                                                if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                                {            
                                                    outputDisplay = String.format("%1$sInstructor could not be created. Using current user as instructor.<br/>", outputDisplay);
                                                }

                                                instructorAresUserName = aresUserName;
                                                instructorAresFamilyName = user.getFamilyName();
                                            }
                                            else
                                            {
                                                if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                                {            
                                                    outputDisplay = String.format("%1$sAssigning Instructor Privileges for %2$s.<br/>", outputDisplay, instructorAresUserName); 
                                                }

                                                boolean instructorPrivs = port.instructorPrivileges(instructorAresUserName);
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                        {            
                                            outputDisplay = String.format("%1$sExternalUserID of %2$s matched Ares Username: %3$s.<br/>", outputDisplay, instructor.getBatchUid(), instructorAresUserName);
                                        }
                                    }
                                }
                                else
                                {
                                    if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                    {            
                                        outputDisplay = String.format("%1$sNo Course Instructors found - Setting instructor to current user<br/>", outputDisplay);
                                    }

                                    instructorAresUserName = aresUserName;
                                    instructorAresFamilyName = user.getFamilyName();
                                }

                                if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                {            
                                    outputDisplay = String.format("%1$sCreating course for Username: %2$s / Family Name: %3$s<br/>", outputDisplay, instructorAresUserName, instructorAresFamilyName);
                                }

                                try
                                {
                                    aresClassId = CreateCourse(instructorAresFamilyName , instructorAresUserName , sessionCourse, out, courseSemester);

                                    if ((aresClassId > 0) && (aresUserName != instructorAresUserName))
                                    {
                                        if (! port.addUserToCourse(aresUserName, aresClassId, com.atlassys.products.ares.webservice.ClassUserType.ProxyInstructor))
                                        {
                                             if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                            {            
                                                outputDisplay = String.format("%1$sError adding %2$s as a proxy to Ares Class ID: %3$s<br/>", outputDisplay, aresUserName, aresClassId.toString());
                                            }       
                                        }
                                    }
                                    else
                                    {
                                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                        {
                                            outputDisplay = String.format("%1$sERROR Creating course for Username:  %2$s / Family Name: %3$s<br/>", outputDisplay, instructorAresUserName, instructorAresFamilyName);
                                        }                                    
                                    }
                                }
                                catch (Exception ex) 
                                {
                                    if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                    {
                                        outputDisplay = String.format("%1$s%2$s<br/>", outputDisplay, ex.getMessage());
                                    }
                                }
                            }
                            else
                            {
                                if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                                {            
                                    outputDisplay = String.format("%1$sNot a valid Course Role for creating the course [Proxy].<br/><br/>", outputDisplay);
                                }
                            }
                        }
                    }
                    else
                    {
                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                        {            
                            outputDisplay = String.format("%1$sNot a valid Course Role for creating the course [Overall].<br/>", outputDisplay);
                        }
                    }

                    if ((aresClassId > 0) && (semesterOptionValue.compareToIgnoreCase("2") == 0))
                    {
                        redirectURL = "manualsemester.jsp?cbuid=" + sessionCourse.getBatchUid() + "&ubuid=" + user.getBatchUid() + "&course_id=" + request.getParameter("course_id");
                        if (verboseErrorValue.equals("2"))
                        {
                            outputDisplay = String.format("%1$sDue to the Verbose Logging Option, The building block will not redirect the user to choose a semester. If Verbose Logging is set to 'No' or 'Yes, for errors', the Building block would redirect to %2$s.<br/>", outputDisplay, redirectURL);
                        }
                        else
                        {
                            sendRedirect = true;
                            redirectForSemester = true;
                        }
                    }
                }
                else
                {
                    pageTitle = studentPageTitleText;
                }

                //Check to see if the Ares Class ID was created in the last step
                if ((! sendRedirect) && (aresClassId > 0))
                {
                    if (verboseErrorValue.equals("2"))
                    {                        
                        outputDisplay = String.format("%1$sChecking for Ares Course User for ClassId: %2$s. User: %3$s.<br/>", outputDisplay, aresClassId, aresUserName);
                    }
                    
                    com.atlassys.products.ares.webservice.ClassUserType currentType = port.retrieveCourseMembershipType(aresClassId, aresUserName);

                    if (verboseErrorValue.equals("2"))
                    {                        
                        outputDisplay = String.format("%1$sCurrent Class User Type: %2$s.<br/>", outputDisplay, currentType);                        
                    }
                    
                    if ((currentRole == CourseMembership.Role.INSTRUCTOR) ||
                       (currentRole == CourseMembership.Role.COURSE_BUILDER) ||
                       (currentRole == CourseMembership.Role.TEACHING_ASSISTANT))
                    {                                 

                        if ((currentType != ClassUserType.ProxyInstructor) && (currentType != ClassUserType.Instructor))
                        {
                            
                            if (verboseErrorValue.equals("2"))
                            {                        
                                outputDisplay = String.format("%1$sAssigning Proxy Instructor Privileges to User %2$s for ClassId: %3$s.<br/>", outputDisplay, aresUserName, aresClassId);
                            }
                            
                            if (port.addUserToCourse(aresUserName, aresClassId, com.atlassys.products.ares.webservice.ClassUserType.ProxyInstructor))
                            {
                                currentType = com.atlassys.products.ares.webservice.ClassUserType.ProxyInstructor;
                            }
                        }                    
                    }
                    else
                    {
                        if (currentType == com.atlassys.products.ares.webservice.ClassUserType.NotAffiliated)
                        {
                            
                            if (verboseErrorValue.equals("2"))
                            {                        
                                outputDisplay = String.format("%1$sAdding User %2$s for ClassId: %3$s as a Class User.<br/>", outputDisplay, aresUserName, aresClassId);
                            }
                            
                            if (port.addUserToCourse(aresUserName, aresClassId, ClassUserType.User))
                            {                        
                                currentType = com.atlassys.products.ares.webservice.ClassUserType.User;
                            }
                        }
                    }

                    if ((currentRole == CourseMembership.Role.INSTRUCTOR) ||
                       (currentRole == CourseMembership.Role.COURSE_BUILDER) ||
                       (currentRole == CourseMembership.Role.TEACHING_ASSISTANT))
                    {                  
                        aresCoursePage =  aresInstructorTextAddItems;
                    }
                    else
                    {
                        pageTitle = studentPageTitleText;
                        aresCoursePage = aresStudentTextViewCoursePage;
                    }

                    try
                    {
                        
                        if (verboseErrorValue.equals("2"))
                        {                        
                            outputDisplay = String.format("%1$sCreating an Ares Websession for User %2$s.<br/>", outputDisplay, aresUserName);
                        }
                        
                        aresWebSessionId = port.createWebSession(aresUserName);

                        if ((currentRole == CourseMembership.Role.INSTRUCTOR) ||
                            (currentRole == CourseMembership.Role.COURSE_BUILDER) ||
                            (currentRole == CourseMembership.Role.TEACHING_ASSISTANT))
                        {
                            
                            if (verboseErrorValue.equals("2"))
                            {                        
                                outputDisplay = String.format("%1$sChanging the WebSession for User %2$s , WebSession: %3$s to an Instructor WebSession.<br/>", outputDisplay, aresUserName, aresWebSessionId);
                            }
                            
                            port.updateWebSession(aresWebSessionId, com.atlassys.products.ares.webservice.SessionType.Instructor);
                        }
                        else
                        {
                            if (verboseErrorValue.equals("2"))
                            {                        
                                outputDisplay = String.format("%1$sChanging the WebSession for User %2$s , WebSession: %3$s to a User WebSession.<br/>", outputDisplay, aresUserName, aresWebSessionId);
                            }
                            
                            port.updateWebSession(aresWebSessionId, com.atlassys.products.ares.webservice.SessionType.User);
                        }

                    } 
                    catch (Exception ex) 
                    {
                        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                        {
                            outputDisplay = String.format("%1$s%2$s<br/>", outputDisplay, ex.getMessage());
                        }
                    }
                   
                    redirectURL =  loginURLText + "?SessionID=" + aresWebSessionId + "&Action=10&Form=60&Value=" + aresClassId;

                    if (verboseErrorValue.equals("2"))
                    {
                        outputDisplay = String.format("%1$sDue to the Verbose Logging Option, The building block will not redirect to the Ares Course Page. If Verbose Logging is set to 'No' or 'Yes, for errors', the Building block would redirect to  %2$s.<br/>", outputDisplay, redirectURL);
                    }
                    else
                    {
                       sendRedirect = true;                         
                    }

                }
                // If the semester was invalid, redirect user to choose a semester.
                else if ((aresClassId == INVALID_SEMESTER_RESULT) && (semesterOptionValue.compareToIgnoreCase("2") == 0))
                {
                    redirectURL = "manualsemester.jsp?cbuid=" + sessionCourse.getBatchUid() + "&ubuid=" + user.getBatchUid() + "&course_id=" + request.getParameter("course_id") + "&aresclassid=" + aresClassId;
                    if (verboseErrorValue.equals("2"))
                    {
                        outputDisplay = String.format("%1$sDue to the Verbose Logging Option, The building block will not redirect the user to choose a semester. If Verbose Logging is set to 'No' or 'Yes, for errors', the Building block would redirect to %2$s.<br/>", outputDisplay, redirectURL);
                    }
                    else
                    {
                        sendRedirect = true;
                        redirectForSemester = true;
                    }
                }
                else
                {
                    if (verboseErrorValue.equals("2"))
                    {
                        outputDisplay = String.format("%1$sThe Ares Class was not found or created. Displaying a message to user to have Staff manually create the class in Ares.<br/>", outputDisplay);
                    }

                    pageTitle = instructorPageTitleText;
                    outputDisplay = String.format("%1$s<p>This course has not been activated in Ares Course Reserves. Please contact your Course Reserves Department for assistance. Be sure to provide them with the following id: %2$s</p>", outputDisplay, bbUniqueCourseId);

                    if (verboseErrorValue.equals("1"))
                    {
                        outputDisplay = String.format("%1$sUser BatchUid: %2$s<br/>", outputDisplay, user.getBatchUid());
                        outputDisplay = String.format("%1$sFirstName: %2$s<br/>", outputDisplay, user.getGivenName());
                        outputDisplay = String.format("%1$sLastName: %2$s<br/>", outputDisplay, user.getFamilyName());
                        outputDisplay = String.format("%1$sUsername: %2$s<br/>", outputDisplay, user.getUserName());
                        outputDisplay = String.format("%1$sCurrent Course Role: %2$s<br/>", outputDisplay, currentRole);
                        outputDisplay = String.format("%1$sCourse Batch ID: %2$s<br/>", outputDisplay, sessionCourse.getBatchUid());
                        outputDisplay = String.format("%1$sCourse Duration Type: %2$s<br/>", outputDisplay, sessionCourse.getDurationType());
                        outputDisplay = String.format("%1$sCourse Description: %2$s<br/>", outputDisplay, sessionCourse.getDescription());
                        outputDisplay = String.format("%1$sCourse Start Date: %2$s<br/>", outputDisplay, sessionCourse.getStartDate());
                        outputDisplay = String.format("%1$sCourse End Date: %2$s<br/>", outputDisplay, sessionCourse.getEndDate());
                    }
                }
            }
            catch (Exception ex)
            {
               if (ex.getMessage().indexOf("Invalid UserAgent:") != -1 )
                {
                    pageTitle = "Error";

                    outputDisplay = String.format("%1$sAres Course Reserves currently does not accept connections from Blackboard.", outputDisplay);
                }    
                else
                {
                    pageTitle = "Error";
                    outputDisplay = String.format("%1$sAn error has occurred.<br/><br/>", outputDisplay);                    
                    if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
                    {
                        outputDisplay = String.format("%1$s%2$s", outputDisplay, ex.getMessage());
                    }    
                }
            }
        } 
        catch (Exception pe) 
        {
            // There is no membership record.
            pageTitle = "Error";
            outputDisplay = String.format("%1$s<h4>You do not have permissions to access course reserves for this course.</h4>", outputDisplay);
        }
    }
    catch (Exception pe) 
    {
        if ((verboseErrorValue.equals("1")) || (verboseErrorValue.equals("2")))
        {            
            outputDisplay = String.format("%1$sError encountered: %2$s<br/>", outputDisplay, pe.getMessage());
        }
    }
       
    if ((!(verboseErrorValue.equals("2"))) && (sendRedirect))
    {
        if(redirectForSemester)
        {
            response.sendRedirect(redirectURL);
        }
        else
        {
%>

            <bbNG:breadcrumbBar environment="course" navItem="http://www.google.com">
                <bbNG:breadcrumb><%=pageTitle%></bbNG:breadcrumb>
            </bbNG:breadcrumbBar>
            <bbNG:pageHeader>
                <bbNG:pageTitleBar title="<%=pageTitle%>"></bbNG:pageTitleBar>
            </bbNG:pageHeader>

            <bbNG:jsBlock>
                <script language="javascript" type="text/javascript">
                    FastInit.addOnLoad(addFrame);

                    function addFrame() {
                        var windowHeight = window.innerHeight;  // Firefox

                        if (document.body.clientHeight)   {
                            height = document.body.clientHeight;  // IE
                        }

                        var frameSpan = document.getElementById("aresFrameSpan");
                        height = parseInt(height - frameSpan.offsetTop - 100) + "px";
                        frameSpan.innerHTML = '<iframe id="aresFrame" src="<%=redirectURL%>" width="100%" height="' + height + '" frameborder="0"/>';
                    }
                </script>
            </bbNG:jsBlock>

            <span id="aresFrameSpan"></span>
<%
        }
    }
    else
    {   
%>
        <bbNG:pageHeader>
            <bbNG:pageTitleBar title="Ares Course Reserves Configuration"></bbNG:pageTitleBar>
        </bbNG:pageHeader>
<%    
        out.print(outputDisplay);                       
        out.print(out.getClass().getName());
    }
%>
</bbNG:learningSystemPage>